1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
22 # ensure that TEST_DIRECTORY is an absolute path so that it
23 # is valid even if the current working directory is changed
26 # The TEST_DIRECTORY will always be the path to the "t"
27 # directory in the git.git checkout. This is overridden by
28 # e.g. t/lib-subtest.sh, but only because its $(pwd) is
29 # different. Those tests still set "$TEST_DIRECTORY" to the
32 # See use of "$GIT_BUILD_DIR" and "$TEST_DIRECTORY" below for
33 # hard assumptions about "$GIT_BUILD_DIR/t" existing and being
34 # the "$TEST_DIRECTORY", and e.g. "$TEST_DIRECTORY/helper"
36 TEST_DIRECTORY
=$
(cd "$TEST_DIRECTORY" && pwd) ||
exit 1
38 if test -z "$TEST_OUTPUT_DIRECTORY"
40 # Similarly, override this to store the test-results subdir
42 TEST_OUTPUT_DIRECTORY
=$TEST_DIRECTORY
44 GIT_BUILD_DIR
="${TEST_DIRECTORY%/t}"
45 if test "$TEST_DIRECTORY" = "$GIT_BUILD_DIR"
47 echo "PANIC: Running in a $TEST_DIRECTORY that doesn't end in '/t'?" >&2
50 if test -f "$GIT_BUILD_DIR/GIT-BUILD-DIR"
52 GIT_BUILD_DIR
="$(cat "$GIT_BUILD_DIR/GIT-BUILD-DIR
")" ||
exit 1
53 # On Windows, we must convert Windows paths lest they contain a colon
56 GIT_BUILD_DIR
="$(cygpath -au "$GIT_BUILD_DIR")"
61 # Prepend a string to a VAR using an arbitrary ":" delimiter, not
62 # adding the delimiter if VAR or VALUE is empty. I.e. a generalized:
64 # VAR=$1${VAR:+${1:+$2}$VAR}
66 # Usage (using ":" as the $2 delimiter):
68 # prepend_var VAR : VALUE
70 eval "$1=\"$3\${$1:+${3:+$2}\$$1}\""
73 # If [AL]SAN is in effect we want to abort so that we notice
74 # problems. The GIT_SAN_OPTIONS variable can be used to set common
75 # defaults shared between [AL]SAN_OPTIONS.
76 prepend_var GIT_SAN_OPTIONS
: abort_on_error
=1
77 prepend_var GIT_SAN_OPTIONS
: strip_path_prefix
="$GIT_BUILD_DIR/"
79 # If we were built with ASAN, it may complain about leaks
80 # of program-lifetime variables. Disable it by default to lower
81 # the noise level. This needs to happen at the start of the script,
82 # before we even do our "did we build git yet" check (since we don't
83 # want that one to complain to stderr).
84 prepend_var ASAN_OPTIONS
: $GIT_SAN_OPTIONS
85 prepend_var ASAN_OPTIONS
: detect_leaks
=0
88 prepend_var LSAN_OPTIONS
: $GIT_SAN_OPTIONS
89 prepend_var LSAN_OPTIONS
: fast_unwind_on_malloc
=0
92 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
94 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
97 .
"$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
98 export PERL_PATH SHELL_PATH
100 # In t0000, we need to override test directories of nested testcases. In case
101 # the developer has TEST_OUTPUT_DIRECTORY part of his build options, then we'd
102 # reset this value to instead contain what the developer has specified. We thus
103 # have this knob to allow overriding the directory.
104 if test -n "${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
106 TEST_OUTPUT_DIRECTORY
="${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
109 # Disallow the use of abbreviated options in the test suite by default
110 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
112 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
=true
113 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
116 # Explicitly set the default branch name for testing, to avoid the
117 # transitory "git init" warning under --verbose.
118 : ${GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME:=master}
119 export GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME
121 ################################################################
122 # It appears that people try to run tests without building...
123 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev
/null
126 if test -n "$GIT_TEST_INSTALLED"
128 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
130 echo >&2 'error: you do not seem to have built git yet.'
138 # $2: name of the var where the arg will be stored
139 mark_option_requires_arg
() {
140 if test -n "$opt_required_arg"
142 echo "error: options that require args cannot be bundled" \
143 "together: '$opt_required_arg' and '$1'" >&2
150 # These functions can be overridden e.g. to output JUnit XML
151 start_test_output
() { :; }
152 start_test_case_output
() { :; }
153 finalize_test_case_output
() { :; }
154 finalize_test_output
() { :; }
160 -d|
--d|
--de|
--deb|
--debu|
--debug)
162 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
164 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
165 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
;;
167 mark_option_requires_arg
"$opt" run_list
170 run_list
=${opt#--*=} ;;
171 -h|
--h|
--he|
--hel|
--help)
173 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
176 verbose_only
=${opt#--*=}
178 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
179 # Ignore --quiet under a TAP::Harness. Saying how many tests
180 # passed without the ok/not ok details is always an error.
181 test -z "$HARNESS_ACTIVE" && quiet
=t
;;
188 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
197 valgrind_only
=${opt#--*=}
205 GIT_TEST_CHAIN_LINT
=1 ;;
207 GIT_TEST_CHAIN_LINT
=0 ;;
215 .
"$TEST_DIRECTORY/test-lib-junit.sh"
217 --github-workflow-markup)
218 .
"$TEST_DIRECTORY/test-lib-github-workflow-markup.sh"
223 echo "error: --stress does not accept an argument: '$opt'" >&2
224 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
229 stress_jobs
=${opt#--*=}
230 case "$stress_jobs" in
232 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
241 stress_limit
=${opt#--*=}
242 case "$stress_limit" in
244 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
255 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
259 # Parse options while taking care to leave $@ intact, so we will still
260 # have all the original command line options when executing the test
261 # script again for '--tee' and '--verbose-log' later.
264 if test -n "$store_arg_to"
266 eval $store_arg_to=\
$opt
274 parse_option
"$opt" ;;
276 # bundled short options must be fed separately to parse_option
283 parse_option
"-$this"
287 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
290 if test -n "$store_arg_to"
292 echo "error: $opt_required_arg requires an argument" >&2
296 if test -n "$valgrind_only"
298 test -z "$valgrind" && valgrind
=memcheck
299 test -z "$verbose" && verbose_only
="$valgrind_only"
300 elif test -n "$valgrind"
302 test -z "$verbose_log" && verbose
=t
312 TEST_STRESS_JOB_SFX
="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
313 TEST_NAME
="$(basename "$0" .sh)"
314 TEST_NUMBER
="${TEST_NAME%%-*}"
315 TEST_NUMBER
="${TEST_NUMBER#t}"
316 TEST_RESULTS_DIR
="$TEST_OUTPUT_DIRECTORY/test-results"
317 TEST_RESULTS_BASE
="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
318 TEST_RESULTS_SAN_FILE_PFX
=trace
319 TEST_RESULTS_SAN_DIR_SFX
=leak
320 TEST_RESULTS_SAN_FILE
=
321 TEST_RESULTS_SAN_DIR
="$TEST_RESULTS_DIR/$TEST_NAME.$TEST_RESULTS_SAN_DIR_SFX"
322 TEST_RESULTS_SAN_DIR_NR_LEAKS_STARTUP
=
323 TRASH_DIRECTORY
="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
324 test -n "$root" && TRASH_DIRECTORY
="$root/$TRASH_DIRECTORY"
325 case "$TRASH_DIRECTORY" in
326 /*) ;; # absolute path is good
327 *) TRASH_DIRECTORY
="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
330 # Utility functions using $TEST_RESULTS_* variables
331 nr_san_dir_leaks_
() {
332 # stderr piped to /dev/null because the directory may have
333 # been "rmdir"'d already.
334 find "$TEST_RESULTS_SAN_DIR" \
336 -name "$TEST_RESULTS_SAN_FILE_PFX.*" 2>/dev
/null |
340 # If --stress was passed, run this test repeatedly in several parallel loops.
341 if test "$GIT_TEST_STRESS_STARTED" = "done"
343 : # Don't stress test again.
344 elif test -n "$stress"
346 if test -n "$stress_jobs"
348 job_count
=$stress_jobs
349 elif test -n "$GIT_TEST_STRESS_LOAD"
351 job_count
="$GIT_TEST_STRESS_LOAD"
352 elif job_count
=$
(getconf _NPROCESSORS_ONLN
2>/dev
/null
) &&
355 job_count
=$
((2 * $job_count))
360 mkdir
-p "$TEST_RESULTS_DIR"
361 stressfail
="$TEST_RESULTS_BASE.stress-failed"
366 kill $job_pids 2>/dev/null
373 while test $job_nr -lt "$job_count"
376 GIT_TEST_STRESS_STARTED
=done
377 GIT_TEST_STRESS_JOB_NR
=$job_nr
378 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
381 kill $test_pid 2>/dev/null
387 while ! test -e "$stressfail" &&
388 { test -z "$stress_limit" ||
389 test $cnt -le $stress_limit ; }
391 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
396 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
398 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
399 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
404 job_pids
="$job_pids $!"
405 job_nr
=$
(($job_nr + 1))
410 if test -f "$stressfail"
413 echo "Log(s) of failed test run(s):"
414 for failed_job_nr
in $
(sort -n "$stressfail")
416 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
417 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
419 rm -rf "$TRASH_DIRECTORY.stress-failed"
421 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
427 # if --tee was passed, write the output not only to the terminal, but
428 # additionally to the file test-results/$BASENAME.out, too.
429 if test "$GIT_TEST_TEE_STARTED" = "done"
431 : # do not redirect again
434 mkdir
-p "$TEST_RESULTS_DIR"
436 # Make this filename available to the sub-process in case it is using
438 GIT_TEST_TEE_OUTPUT_FILE
=$TEST_RESULTS_BASE.out
439 export GIT_TEST_TEE_OUTPUT_FILE
441 # Truncate before calling "tee -a" to get rid of the results
442 # from any previous runs.
443 >"$GIT_TEST_TEE_OUTPUT_FILE"
445 (GIT_TEST_TEE_STARTED
=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
446 echo $?
>"$TEST_RESULTS_BASE.exit") |
tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
447 test "$(cat "$TEST_RESULTS_BASE.
exit")" = 0
451 if test -n "$trace" && test -n "$test_untraceable"
453 # '-x' tracing requested, but this test script can't be reliably
454 # traced, unless it is run with a Bash version supporting
455 # BASH_XTRACEFD (introduced in Bash v4.1).
457 # Perform this version check _after_ the test script was
458 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
459 # '--verbose-log', so the right shell is checked and the
460 # warning is issued only once.
461 if test -n "$BASH_VERSION" && eval '
462 test ${BASH_VERSINFO[0]} -gt 4 || {
463 test ${BASH_VERSINFO[0]} -eq 4 &&
464 test ${BASH_VERSINFO[1]} -ge 1
468 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
470 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
474 if test -n "$trace" && test -z "$verbose_log"
479 # Since bash 5.0, checkwinsize is enabled by default which does
480 # update the COLUMNS variable every time a non-builtin command
481 # completes, even for non-interactive shells.
482 # Disable that since we are aiming for repeatability.
483 test -n "$BASH_VERSION" && shopt -u checkwinsize
2>/dev
/null
485 # For repeatability, reset the environment to known value.
486 # TERM is sanitized below, after saving color control sequences.
492 export LANG LC_ALL PAGER TZ COLUMNS
495 # A call to "unset" with no arguments causes at least Solaris 10
496 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
497 # deriving from the command substitution clustered with the other
499 unset VISUAL EMAIL LANGUAGE $
("$PERL_PATH" -e '
501 my $ok = join("|", qw(
513 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
514 print join("\n", @vars);
517 unset XDG_CONFIG_HOME
519 unset GIT_TRACE2_PARENT_NAME
520 unset GIT_TRACE2_PARENT_SID
521 TEST_AUTHOR_LOCALNAME
=author
522 TEST_AUTHOR_DOMAIN
=example.com
523 GIT_AUTHOR_EMAIL
=${TEST_AUTHOR_LOCALNAME}@
${TEST_AUTHOR_DOMAIN}
524 GIT_AUTHOR_NAME
='A U Thor'
525 GIT_AUTHOR_DATE
='1112354055 +0200'
526 TEST_COMMITTER_LOCALNAME
=committer
527 TEST_COMMITTER_DOMAIN
=example.com
528 GIT_COMMITTER_EMAIL
=${TEST_COMMITTER_LOCALNAME}@
${TEST_COMMITTER_DOMAIN}
529 GIT_COMMITTER_NAME
='C O Mitter'
530 GIT_COMMITTER_DATE
='1112354055 +0200'
531 GIT_MERGE_VERBOSITY
=5
532 GIT_MERGE_AUTOEDIT
=no
533 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
534 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
535 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
536 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
539 GIT_DEFAULT_HASH
="${GIT_TEST_DEFAULT_HASH:-sha1}"
540 export GIT_DEFAULT_HASH
541 GIT_TEST_MERGE_ALGORITHM
="${GIT_TEST_MERGE_ALGORITHM:-ort}"
542 export GIT_TEST_MERGE_ALGORITHM
544 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
546 export GIT_TRACE_BARE
548 # Some tests scan the GIT_TRACE2_EVENT feed for events, but the
549 # default depth is 2, which frequently causes issues when the
550 # events are wrapped in new regions. Set it to a sufficiently
551 # large depth to avoid custom changes in the test suite.
552 GIT_TRACE2_EVENT_NESTING
=100
553 export GIT_TRACE2_EVENT_NESTING
555 # Use specific version of the index file format
556 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
558 GIT_INDEX_VERSION
="$GIT_TEST_INDEX_VERSION"
559 export GIT_INDEX_VERSION
562 if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
564 GIT_PERL_FATAL_WARNINGS
=1
565 export GIT_PERL_FATAL_WARNINGS
568 case $GIT_TEST_FSYNC in
571 export GIT_TEST_FSYNC
575 # Add libc MALLOC and MALLOC_PERTURB test only if we are not executing
576 # the test with valgrind and have not compiled with conflict SANITIZE
578 if test -n "$valgrind" ||
579 test -n "$SANITIZE_ADDRESS" ||
580 test -n "$SANITIZE_LEAK" ||
581 test -n "$TEST_NO_MALLOC_CHECK"
583 setup_malloc_check
() {
586 teardown_malloc_check
() {
591 if _GLIBC_VERSION
=$
(getconf GNU_LIBC_VERSION
2>/dev
/null
) &&
592 _GLIBC_VERSION
=${_GLIBC_VERSION#"glibc "} &&
593 expr 2.34 \
<= "$_GLIBC_VERSION" >/dev
/null
595 _USE_GLIBC_TUNABLES
=YesPlease
597 setup_malloc_check
() {
600 MALLOC_CHECK_
=3 MALLOC_PERTURB_
=165
601 export MALLOC_CHECK_ MALLOC_PERTURB_
602 if test -n "$_USE_GLIBC_TUNABLES"
605 LD_PRELOAD
="libc_malloc_debug.so.0"
607 glibc.malloc.check
=1 \
608 glibc.malloc.perturb
=165
613 export LD_PRELOAD GLIBC_TUNABLES
616 teardown_malloc_check
() {
617 unset MALLOC_CHECK_ MALLOC_PERTURB_
618 unset LD_PRELOAD GLIBC_TUNABLES
622 # Protect ourselves from common misconfiguration to export
623 # CDPATH into the environment
629 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
642 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
643 # when case-folding filenames
644 u200c
=$
(printf '\342\200\214')
646 export _x05 _x35 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
648 test "x$TERM" != "xdumb" && (
650 tput bold
>/dev
/null
2>&1 &&
651 tput setaf
1 >/dev
/null
2>&1 &&
652 tput sgr0
>/dev
/null
2>&1
658 # Save the color control sequences now rather than run tput
659 # each time say_color() is called. This is done for two
661 # * TERM will be changed to dumb
662 # * HOME will be changed to a temporary directory and tput
663 # might need to read ~/.terminfo from the original HOME
664 # directory to get the control sequences
665 # Note: This approach assumes the control sequences don't end
666 # in a newline for any terminal of interest (command
667 # substitutions strip trailing newlines). Given that most
668 # (all?) terminals in common use are related to ECMA-48, this
669 # shouldn't be a problem.
670 say_color_error
=$
(tput bold
; tput setaf
1) # bold red
671 say_color_skip
=$
(tput setaf
4) # blue
672 say_color_warn
=$
(tput setaf
3) # brown/yellow
673 say_color_pass
=$
(tput setaf
2) # green
674 say_color_info
=$
(tput setaf
6) # cyan
675 say_color_reset
=$
(tput sgr0
)
676 say_color_
="" # no formatting for normal text
678 test -z "$1" && test -n "$quiet" && return
679 eval "say_color_color=\$say_color_$1"
681 printf "%s\\n" "$say_color_color$*$say_color_reset"
685 test -z "$1" && test -n "$quiet" && return
693 export TERM USER_TERM
695 # What is written by tests to stdout and stderr is sent to different places
696 # depending on the test mode (e.g. /dev/null in non-verbose mode, piped to tee
697 # with --tee option, etc.). We save the original stdin to FD #6 and stdout and
698 # stderr to #5 and #7, so that the test framework can use them (e.g. for
699 # printing errors within the test framework) independently of the test mode.
711 say_color error
"error: $*"
716 error
>&7 "bug in the test script: $*"
720 test $# -ne 1 && BUG
"1 param"
722 # Do not change "Bail out! " string. It's part of TAP syntax:
723 # https://testanything.org/tap-specification.html
724 local bail_out
="Bail out! "
727 say_color
>&5 error
$bail_out "$message"
735 if test -n "$HARNESS_ACTIVE"
737 if test "$verbose" = t ||
test -n "$verbose_only"
739 BAIL_OUT
'verbose mode forbidden under TAP harness; try --verbose-log'
743 test "${test_description}" != "" ||
744 error
"Test script did not set test_description."
746 if test "$help" = "t"
748 printf '%s\n' "$test_description"
752 if test "$verbose_log" = "t"
754 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
755 elif test "$verbose" = "t"
759 exec 4>/dev
/null
3>/dev
/null
762 # Send any "-x" output directly to stderr to avoid polluting tests
763 # which capture stderr. We can do this unconditionally since it
764 # has no effect if tracing isn't turned on.
766 # Note that this sets up the trace fd as soon as we assign the variable, so it
767 # must come after the creation of descriptor 4 above. Likewise, we must never
768 # unset this, as it has the side effect of closing descriptor 4, which we
769 # use to show verbose tests to the user.
771 # Note also that we don't need or want to export it. The tracing is local to
772 # this shell, and we would not want to influence any shells we exec.
783 test_external_has_tap
=0
787 # This is responsible for running the atexit commands even when a
788 # test script run with '--immediate' fails, or when the user hits
789 # ctrl-C, i.e. when 'test_done' is not invoked at all.
790 test_atexit_handler || code
=$?
791 if test -n "$GIT_EXIT_OK"
795 echo >&5 "FATAL: Unexpected exit with code $code"
802 # Disable '-x' tracing, because with some shells, notably dash, it
803 # prevents running the cleanup commands when a test script run with
804 # '--verbose-log -x' is interrupted.
805 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
807 # The user-facing functions are loaded from a separate file so that
808 # test_perf subshells can have them too
809 .
"$TEST_DIRECTORY/test-lib-functions.sh"
811 # You are not expected to call test_ok_ and test_failure_ directly, use
812 # the test_expect_* functions instead.
815 test_success
=$
(($test_success + 1))
816 say_color
"" "ok $test_count - $@"
817 finalize_test_case_output ok
"$@"
820 _invert_exit_code_failure_end_blurb
() {
821 say_color warn
"# faked up failures as TODO & now exiting with 0 due to --invert-exit-code"
826 test_failure
=$
(($test_failure + 1))
828 if test -n "$invert_exit_code" # && test -n "$HARNESS_ACTIVE"
830 pfx
="# TODO induced breakage (--invert-exit-code):"
832 say_color error
"not ok $test_count - ${pfx:+$pfx }$1"
834 printf '%s\n' "$*" |
sed -e 's/^/# /'
835 if test -n "$immediate"
837 say_color error
"1..$test_count"
838 if test -n "$invert_exit_code"
841 _invert_exit_code_failure_end_blurb
847 finalize_test_case_output failure
"$failure_label" "$@"
850 test_known_broken_ok_
() {
851 test_fixed
=$
(($test_fixed+1))
852 say_color error
"ok $test_count - $1 # TODO known breakage vanished"
853 finalize_test_case_output fixed
"$1"
856 test_known_broken_failure_
() {
857 test_broken
=$
(($test_broken+1))
858 say_color warn
"not ok $test_count - $1 # TODO known breakage"
859 finalize_test_case_output broken
"$1"
863 test "$debug" = "" ||
eval "$1"
866 match_pattern_list
() {
869 test -z "$*" && return 1
870 # We need to use "$*" to get field-splitting, but we want to
871 # disable globbing, since we are matching against an arbitrary
872 # $arg, not what's in the filesystem. Using "set -f" accomplishes
873 # that, but we must do it in a subshell to avoid impacting the
874 # rest of the script. The exit value of the subshell becomes
875 # the function's return value.
890 match_test_selector_list
() {
897 test -z "$1" && return 0
899 # Commas are accepted as separators.
905 # If the first selector is negative we include by default.
913 orig_selector
=$selector
919 selector
=${selector##?}
923 test -z "$selector" && continue
927 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev
/null
929 echo "error: $operation: invalid non-numeric in range" \
930 "start: '$orig_selector'" >&2
933 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev
/null
935 echo "error: $operation: invalid non-numeric in range" \
936 "end: '$orig_selector'" >&2
941 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev
/null
943 case "$title" in *${selector}*)
951 # Short cut for "obvious" cases
952 test -z "$include" && test -z "$positive" && continue
953 test -n "$include" && test -n "$positive" && continue
957 if test $arg -le ${selector#-}
963 if test $arg -ge ${selector%-}
969 if test ${selector%%-*} -le $arg \
970 && test $arg -le ${selector#*-}
976 if test $arg -eq $selector
987 maybe_teardown_verbose
() {
988 test -z "$verbose_only" && return
989 exec 4>/dev
/null
3>/dev
/null
994 maybe_setup_verbose
() {
995 test -z "$verbose_only" && return
996 if match_pattern_list
$test_count "$verbose_only"
999 # Emit a delimiting blank line when going from
1000 # non-verbose to verbose. Within verbose mode the
1001 # delimiter is printed by test_expect_*. The choice
1002 # of the initial $last_verbose is such that before
1003 # test 1, we do not print it.
1004 test -z "$last_verbose" && echo >&3 ""
1007 exec 4>/dev
/null
3>/dev
/null
1010 last_verbose
=$verbose
1013 maybe_teardown_valgrind
() {
1014 test -z "$GIT_VALGRIND" && return
1015 GIT_VALGRIND_ENABLED
=
1018 maybe_setup_valgrind
() {
1019 test -z "$GIT_VALGRIND" && return
1020 if test -z "$valgrind_only"
1022 GIT_VALGRIND_ENABLED
=t
1025 GIT_VALGRIND_ENABLED
=
1026 if match_pattern_list
$test_count "$valgrind_only"
1028 GIT_VALGRIND_ENABLED
=t
1034 test "$trace" = t
&& {
1035 test "$verbose" = t ||
test "$verbose_log" = t
1039 # This is a separate function because some tests use
1040 # "return" to end a test_expect_success block early
1041 # (and we want to make sure we run any cleanup like
1043 test_eval_inner_
() {
1048 # If "-x" tracing is in effect, then we want to avoid polluting stderr
1049 # with non-test commands. But once in "set -x" mode, we cannot prevent
1050 # the shell from printing the "set +x" to turn it off (nor the saving
1051 # of $? before that). But we can make sure that the output goes to
1054 # There are a few subtleties here:
1056 # - we have to redirect descriptor 4 in addition to 2, to cover
1059 # - the actual eval has to come before the redirection block (since
1060 # it needs to see descriptor 4 to set up its stderr)
1062 # - likewise, any error message we print must be outside the block to
1063 # access descriptor 4
1065 # - checking $? has to come immediately after the eval, but it must
1066 # be _inside_ the block to avoid polluting the "set -x" output
1069 # Do not add anything extra (including LF) after '$*'
1070 test_eval_inner_
</dev
/null
>&3 2>&4 "
1071 want_trace && trace_level_=$(($trace_level_+1)) && set -x
1077 test 1 = $trace_level_ && set +x
1078 trace_level_
=$
(($trace_level_-1))
1082 if test "$test_eval_ret_" != 0 && want_trace
1084 say_color error
>&4 "error: last command exited with \$?=$test_eval_ret_"
1086 return $test_eval_ret_
1095 expecting_failure
=$2
1097 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
1098 # 117 is magic because it is unlikely to match the exit
1099 # code of other programs
1100 test_eval_inner_
"fail_117 && $1" </dev
/null
>&3 2>&4
1103 BUG
"broken &&-chain: $1"
1110 teardown_malloc_check
1112 if test -z "$immediate" ||
test $eval_ret = 0 ||
1113 test -n "$expecting_failure" && test "$test_cleanup" != ":"
1116 test_eval_
"$test_cleanup"
1117 teardown_malloc_check
1119 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
1127 test_count
=$
(($test_count+1))
1129 maybe_setup_valgrind
1130 start_test_case_output
"$@"
1135 maybe_teardown_valgrind
1136 maybe_teardown_verbose
1137 if test -n "$GIT_TEST_TEE_OFFSET"
1139 GIT_TEST_TEE_OFFSET
=$
(test-tool path-utils file-size \
1140 "$GIT_TEST_TEE_OUTPUT_FILE")
1147 if match_pattern_list
$this_test.
$test_count "$GIT_SKIP_TESTS"
1150 skipped_reason
="GIT_SKIP_TESTS"
1152 if test -z "$to_skip" && test -n "$run_list" &&
1153 ! match_test_selector_list
'--run' "$1" $test_count "$run_list"
1156 skipped_reason
="--run"
1158 if test -z "$to_skip" && test -n "$test_prereq" &&
1159 ! test_have_prereq
"$test_prereq"
1164 if test "$missing_prereq" != "$test_prereq"
1166 of_prereq
=" of $test_prereq"
1168 skipped_reason
="missing $missing_prereq${of_prereq}"
1170 # Keep a list of all the missing prereq for result aggregation
1171 if test -z "$missing_prereq"
1173 test_missing_prereq
=$missing_prereq
1175 test_missing_prereq
="$test_missing_prereq,$missing_prereq"
1182 say_color skip
"ok $test_count # skip $1 ($skipped_reason)"
1184 finalize_test_case_output skip
"$@"
1192 # stub; perf-lib overrides it
1193 test_at_end_hook_
() {
1197 test_atexit_cleanup
=:
1198 test_atexit_handler
() {
1199 # In a succeeding test script 'test_atexit_handler' is invoked
1200 # twice: first from 'test_done', then from 'die' in the trap on
1202 # This condition and resetting 'test_atexit_cleanup' below makes
1203 # sure that the registered cleanup commands are run only once.
1204 test : != "$test_atexit_cleanup" ||
return 0
1207 test_eval_
"$test_atexit_cleanup"
1208 test_atexit_cleanup
=:
1209 teardown_malloc_check
1212 sanitize_leak_log_message_
() {
1217 printf "With SANITIZE=leak at exit we have %d leak logs, but started with %d
1219 This means that we have a blindspot where git is leaking but we're
1220 losing the exit code somewhere, or not propagating it appropriately
1223 See the logs at \"%s.*\";
1224 those logs are reproduced below." \
1225 "$new" "$old" "$file"
1228 check_test_results_san_file_
() {
1229 if test -z "$TEST_RESULTS_SAN_FILE"
1233 local old
="$TEST_RESULTS_SAN_DIR_NR_LEAKS_STARTUP" &&
1234 local new
="$(nr_san_dir_leaks_)" &&
1236 if test $new -le $old
1240 local out
="$(sanitize_leak_log_message_ "$new" "$old" "$TEST_RESULTS_SAN_FILE")" &&
1241 say_color error
"$out" &&
1245 say_color error
"The logs include output from past runs to avoid" &&
1246 say_color error
"that remove 'test-results' between runs."
1248 say_color error
"$(cat "$TEST_RESULTS_SAN_FILE".*)" &&
1250 if test -n "$passes_sanitize_leak" && test "$test_failure" = 0
1252 say
"As TEST_PASSES_SANITIZE_LEAK=true and our logs show we're leaking, exit non-zero!" &&
1254 elif test -n "$passes_sanitize_leak"
1256 say
"As TEST_PASSES_SANITIZE_LEAK=true and our logs show we're leaking, and we're failing for other reasons too..." &&
1258 elif test -n "$sanitize_leak_check" && test "$test_failure" = 0
1260 say
"As TEST_PASSES_SANITIZE_LEAK=true isn't set the above leak is 'ok' with GIT_TEST_PASSING_SANITIZE_LEAK=check" &&
1262 elif test -n "$sanitize_leak_check"
1264 say
"As TEST_PASSES_SANITIZE_LEAK=true isn't set the above leak is 'ok' with GIT_TEST_PASSING_SANITIZE_LEAK=check" &&
1267 say
"With GIT_TEST_SANITIZE_LEAK_LOG=true our logs revealed a memory leak, exit non-zero!" &&
1273 # Run the atexit commands _before_ the trash directory is
1274 # removed, so the commands can access pidfiles and socket files.
1277 finalize_test_output
1279 if test -z "$HARNESS_ACTIVE"
1281 mkdir
-p "$TEST_RESULTS_DIR"
1283 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1285 success $test_success
1288 failed $test_failure
1289 missing_prereq $test_missing_prereq
1294 if test "$test_fixed" != 0
1296 say_color error
"# $test_fixed known breakage(s) vanished; please update test(s)"
1298 if test "$test_broken" != 0
1300 say_color warn
"# still have $test_broken known breakage(s)"
1302 if test "$test_broken" != 0 ||
test "$test_fixed" != 0
1304 test_remaining
=$
(( $test_count - $test_broken - $test_fixed ))
1305 msg
="remaining $test_remaining test(s)"
1307 test_remaining
=$test_count
1308 msg
="$test_count test(s)"
1310 case "$test_failure" in
1312 if test $test_remaining -gt 0
1314 say_color pass
"# passed all $msg"
1317 # Maybe print SKIP message
1318 test -z "$skip_all" || skip_all
="# SKIP $skip_all"
1319 case "$test_count" in
1321 say
"1..$test_count${skip_all:+ $skip_all}"
1324 test -z "$skip_all" ||
1325 say_color warn
"$skip_all"
1326 say
"1..$test_count"
1330 if test -n "$stress" && test -n "$invert_exit_code"
1332 # We're about to move our "$TRASH_DIRECTORY"
1333 # to "$TRASH_DIRECTORY.stress-failed" if
1334 # --stress is combined with
1335 # --invert-exit-code.
1336 say
"with --stress and --invert-exit-code we're not removing '$TRASH_DIRECTORY'"
1337 elif test -z "$debug" && test -n "$remove_trash"
1339 test -d "$TRASH_DIRECTORY" ||
1340 error
"Tests passed but trash directory already removed before test cleanup; aborting"
1342 cd "$TRASH_DIRECTORY/.." &&
1343 rm -fr "$TRASH_DIRECTORY" ||
{
1344 # try again in a bit
1346 rm -fr "$TRASH_DIRECTORY"
1348 error
"Tests passed but test cleanup failed; aborting"
1351 check_test_results_san_file_
"$test_failure"
1353 if test -z "$skip_all" && test -n "$invert_exit_code"
1355 say_color warn
"# faking up non-zero exit with --invert-exit-code"
1366 say_color error
"# failed $test_failure among $msg"
1367 say
"1..$test_count"
1369 check_test_results_san_file_
"$test_failure"
1371 if test -n "$invert_exit_code"
1373 _invert_exit_code_failure_end_blurb
1384 if test -n "$valgrind"
1388 test "$1" = "$(readlink "$2")" ||
{
1396 while test -d "$2".lock
1398 say
"Waiting for lock on $2."
1405 make_valgrind_symlink
() {
1406 # handle only executables, unless they are shell libraries that
1407 # need to be in the exec-path.
1409 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1412 base
=$
(basename "$1")
1415 symlink_target
="$GIT_BUILD_DIR/t/helper/$base"
1418 symlink_target
="$GIT_BUILD_DIR/$base"
1421 # do not override scripts
1422 if test -x "$symlink_target" &&
1423 test ! -d "$symlink_target" &&
1424 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1426 symlink_target
=..
/valgrind.sh
1430 symlink_target
=..
/unprocessed-script
1432 # create the link, or replace it if it is out of date
1433 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
1436 # override all git executables in TEST_DIRECTORY/..
1437 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
1438 mkdir
-p "$GIT_VALGRIND"/bin
1439 for file in $GIT_BUILD_DIR/git
* $GIT_BUILD_DIR/t
/helper
/test-
*
1441 make_valgrind_symlink
$file
1443 # special-case the mergetools loadables
1444 make_symlink
"$GIT_BUILD_DIR"/mergetools
"$GIT_VALGRIND/bin/mergetools"
1449 ls "$path"/git-
* 2> /dev
/null |
1452 make_valgrind_symlink
"$file"
1456 PATH
=$GIT_VALGRIND/bin
:$PATH
1457 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
1459 GIT_VALGRIND_MODE
="$valgrind"
1460 export GIT_VALGRIND_MODE
1461 GIT_VALGRIND_ENABLED
=t
1462 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED
=
1463 export GIT_VALGRIND_ENABLED
1464 elif test -n "$GIT_TEST_INSTALLED"
1466 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
1467 error
"Cannot run git from $GIT_TEST_INSTALLED."
1468 PATH
=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t
/helper
:$PATH
1469 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1470 else # normal case, use ../bin-wrappers only unless $with_dashes:
1471 if test -n "$no_bin_wrappers"
1475 git_bin_dir
="$GIT_BUILD_DIR/bin-wrappers"
1476 if ! test -x "$git_bin_dir/git"
1478 if test -z "$with_dashes"
1480 say
"$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1484 PATH
="$git_bin_dir:$PATH"
1486 GIT_EXEC_PATH
=$GIT_BUILD_DIR
1487 if test -n "$with_dashes"
1489 PATH
="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1492 GIT_TEMPLATE_DIR
="$GIT_BUILD_DIR"/templates
/blt
1493 GIT_CONFIG_NOSYSTEM
=1
1495 GIT_CEILING_DIRECTORIES
="$TRASH_DIRECTORY/.."
1496 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM GIT_CEILING_DIRECTORIES
1498 if test -z "$GIT_TEST_CMP"
1500 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1502 GIT_TEST_CMP
="$DIFF -c"
1504 GIT_TEST_CMP
="$DIFF -u"
1508 GITPERLLIB
="$GIT_BUILD_DIR"/perl
/build
/lib
1510 test -d "$GIT_BUILD_DIR"/templates
/blt ||
{
1511 BAIL_OUT
"You haven't built things yet, have you?"
1514 if ! test -x "$GIT_BUILD_DIR"/t
/helper
/test-tool
$X
1516 BAIL_OUT
'You need to build test-tool; Run "make t/helper/test-tool" in the source (toplevel) directory'
1519 # Are we running this test at all?
1522 this_test
=${this_test%%-*}
1523 if match_pattern_list
"$this_test" "$GIT_SKIP_TESTS"
1525 say_color info
>&3 "skipping test $this_test altogether"
1526 skip_all
="skip all tests in $this_test"
1530 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK
() {
1531 BAIL_OUT
"$1 has no effect except when compiled with SANITIZE=leak"
1534 if test -n "$SANITIZE_LEAK"
1536 # Normalize with test_bool_env
1537 passes_sanitize_leak
=
1539 # We need to see TEST_PASSES_SANITIZE_LEAK in "test-tool
1540 # env-helper" (via test_bool_env)
1541 export TEST_PASSES_SANITIZE_LEAK
1542 if test_bool_env TEST_PASSES_SANITIZE_LEAK false
1544 passes_sanitize_leak
=t
1547 if test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check"
1549 sanitize_leak_check
=t
1550 if test -n "$invert_exit_code"
1552 BAIL_OUT
"cannot use --invert-exit-code under GIT_TEST_PASSING_SANITIZE_LEAK=check"
1555 if test -z "$passes_sanitize_leak"
1557 say
"in GIT_TEST_PASSING_SANITIZE_LEAK=check mode, setting --invert-exit-code for TEST_PASSES_SANITIZE_LEAK != true"
1560 elif test -z "$passes_sanitize_leak" &&
1561 test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1563 skip_all
="skipping $this_test under GIT_TEST_PASSING_SANITIZE_LEAK=true"
1567 if test_bool_env GIT_TEST_SANITIZE_LEAK_LOG false
1569 if ! mkdir
-p "$TEST_RESULTS_SAN_DIR"
1571 BAIL_OUT
"cannot create $TEST_RESULTS_SAN_DIR"
1573 TEST_RESULTS_SAN_FILE
="$TEST_RESULTS_SAN_DIR/$TEST_RESULTS_SAN_FILE_PFX"
1575 # In case "test-results" is left over from a previous
1576 # run: Only report if new leaks show up.
1577 TEST_RESULTS_SAN_DIR_NR_LEAKS_STARTUP
=$
(nr_san_dir_leaks_
)
1579 # Don't litter *.leak dirs if there was nothing to report
1580 test_atexit
"rmdir \"$TEST_RESULTS_SAN_DIR\" 2>/dev/null || :"
1582 prepend_var LSAN_OPTIONS
: dedup_token_length
=9999
1583 prepend_var LSAN_OPTIONS
: log_exe_name
=1
1584 prepend_var LSAN_OPTIONS
: log_path
=\"$TEST_RESULTS_SAN_FILE\"
1587 elif test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check" ||
1588 test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1590 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK
"GIT_TEST_PASSING_SANITIZE_LEAK=true"
1591 elif test_bool_env GIT_TEST_SANITIZE_LEAK_LOG false
1593 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK
"GIT_TEST_SANITIZE_LEAK_LOG=true"
1596 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0 &&
1597 test "${GIT_TEST_EXT_CHAIN_LINT:-1}" != 0
1599 "$PERL_PATH" "$TEST_DIRECTORY/chainlint.pl" "$0" ||
1600 BUG
"lint error (see '?!...!? annotations above)"
1603 # Last-minute variable setup
1605 HOME
="$TRASH_DIRECTORY"
1606 GNUPGHOME
="$HOME/gnupg-home-not-used"
1607 export HOME GNUPGHOME USER_HOME
1609 # "rm -rf" existing trash directory, even if a previous run left it
1610 # with bad permissions.
1611 remove_trash_directory
() {
1613 if ! rm -rf "$dir" 2>/dev
/null
1615 chmod -R u
+rwx
"$dir"
1622 remove_trash_directory
"$TRASH_DIRECTORY" ||
{
1623 BAIL_OUT
'cannot prepare test area'
1627 if test -z "$TEST_NO_CREATE_REPO"
1630 ${TEST_CREATE_REPO_NO_TEMPLATE:+--template=} \
1631 "$TRASH_DIRECTORY" >&3 2>&4 ||
1632 error
"cannot run git init"
1634 mkdir
-p "$TRASH_DIRECTORY"
1637 # Use -P to resolve symlinks in our working directory so that the cwd
1638 # in subprocesses like git equals our $PWD (for pathname comparisons).
1639 cd -P "$TRASH_DIRECTORY" || BAIL_OUT
"cannot cd -P to \"$TRASH_DIRECTORY\""
1641 start_test_output
"$0"
1644 # A regexp to match 5 and 35 hexdigits
1645 _x05
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1646 _x35
="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1650 ZERO_OID
=$
(test_oid zero
)
1651 OID_REGEX
=$
(echo $ZERO_OID |
sed -e 's/0/[0-9a-f]/g')
1652 OIDPATH_REGEX
=$
(test_oid_to_path
$ZERO_OID |
sed -e 's/0/[0-9a-f]/g')
1653 EMPTY_TREE
=$
(test_oid empty_tree
)
1654 EMPTY_BLOB
=$
(test_oid empty_blob
)
1656 # Provide an implementation of the 'yes' utility; the upper bound
1657 # limit is there to help Windows that cannot stop this loop from
1658 # wasting cycles when the downstream stops reading, so do not be
1659 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1660 # limit the output of the yes utility", 2016-02-02)
1670 while test $i -lt 99
1677 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1678 # thus needs to be set up really early, and set an internal variable
1679 # for convenience so the hot test_set_prereq() codepath doesn't need
1680 # to call "test-tool env-helper" (via test_bool_env). Only do that work
1681 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1682 GIT_TEST_FAIL_PREREQS_INTERNAL
=
1683 if test -n "$GIT_TEST_FAIL_PREREQS"
1685 if test_bool_env GIT_TEST_FAIL_PREREQS false
1687 GIT_TEST_FAIL_PREREQS_INTERNAL
=true
1688 test_set_prereq FAIL_PREREQS
1691 test_lazy_prereq FAIL_PREREQS
'
1692 test_bool_env GIT_TEST_FAIL_PREREQS false
1696 # Fix some commands on Windows, and other OS-specific things
1700 # Windows has its own (incompatible) sort and find
1707 # git sees Windows-style pwd
1711 # no POSIX permissions
1712 # backslashes in pathspec are converted to '/'
1713 # exec does not inherit the PID
1714 test_set_prereq MINGW
1715 test_set_prereq NATIVE_CRLF
1716 test_set_prereq SED_STRIPS_CR
1717 test_set_prereq GREP_STRIPS_CR
1718 test_set_prereq WINDOWS
1719 GIT_TEST_CMP
="GIT_DIR=/dev/null git diff --no-index --ignore-cr-at-eol --"
1722 test_set_prereq POSIXPERM
1723 test_set_prereq EXECKEEPSPID
1724 test_set_prereq CYGWIN
1725 test_set_prereq SED_STRIPS_CR
1726 test_set_prereq GREP_STRIPS_CR
1727 test_set_prereq WINDOWS
1730 test_set_prereq POSIXPERM
1731 test_set_prereq BSLASHPSPEC
1732 test_set_prereq EXECKEEPSPID
1736 # Detect arches where a few things don't work
1740 test_set_prereq HPPA
1744 test_set_prereq REFFILES
1746 ( COLUMNS
=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1747 test -z "$NO_CURL" && test_set_prereq LIBCURL
1748 test -z "$NO_PERL" && test_set_prereq PERL
1749 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1750 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1751 test -n "$USE_LIBPCRE2" && test_set_prereq PCRE
1752 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1753 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1754 test -n "$SANITIZE_LEAK" && test_set_prereq SANITIZE_LEAK
1755 test -n "$GIT_VALGRIND_ENABLED" && test_set_prereq VALGRIND
1757 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1759 GIT_TEST_CHECK_CACHE_TREE
=true
1760 export GIT_TEST_CHECK_CACHE_TREE
1763 test_lazy_prereq PIPE
'
1764 # test whether the filesystem supports FIFOs
1765 test_have_prereq !MINGW,!CYGWIN &&
1766 rm -f testfifo && mkfifo testfifo
1769 test_lazy_prereq SYMLINKS
'
1770 # test whether the filesystem supports symbolic links
1771 ln -s x y && test -h y
1774 test_lazy_prereq SYMLINKS_WINDOWS
'
1775 # test whether symbolic links are enabled on Windows
1776 test_have_prereq MINGW &&
1777 cmd //c "mklink y x" &> /dev/null && test -h y
1780 test_lazy_prereq FILEMODE
'
1781 test "$(git config --bool core.filemode)" = true
1784 test_lazy_prereq CASE_INSENSITIVE_FS
'
1785 echo good >CamelCase &&
1786 echo bad >camelcase &&
1787 test "$(cat CamelCase)" != good
1790 test_lazy_prereq FUNNYNAMES
'
1791 test_have_prereq !MINGW &&
1793 "FUNNYNAMES tab embedded" \
1794 "FUNNYNAMES \"quote embedded\"" \
1796 embedded" 2>/dev/null &&
1798 "FUNNYNAMES tab embedded" \
1799 "FUNNYNAMES \"quote embedded\"" \
1801 embedded" 2>/dev/null
1804 test_lazy_prereq UTF8_NFD_TO_NFC
'
1805 # check whether FS converts nfd unicode to nfc
1806 auml=$(printf "\303\244")
1807 aumlcdiar=$(printf "\141\314\210")
1809 test -f "$aumlcdiar"
1812 test_lazy_prereq AUTOIDENT
'
1813 sane_unset GIT_AUTHOR_NAME &&
1814 sane_unset GIT_AUTHOR_EMAIL &&
1815 git var GIT_AUTHOR_IDENT
1818 test_lazy_prereq EXPENSIVE
'
1819 test -n "$GIT_TEST_LONG"
1822 test_lazy_prereq EXPENSIVE_ON_WINDOWS
'
1823 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1826 test_lazy_prereq USR_BIN_TIME
'
1827 test -x /usr/bin/time
1830 test_lazy_prereq NOT_ROOT
'
1835 test_lazy_prereq JGIT
'
1839 # SANITY is about "can you correctly predict what the filesystem would
1840 # do by only looking at the permission bits of the files and
1841 # directories?" A typical example of !SANITY is running the test
1842 # suite as root, where a test may expect "chmod -r file && cat file"
1843 # to fail because file is supposed to be unreadable after a successful
1844 # chmod. In an environment (i.e. combination of what filesystem is
1845 # being used and who is running the tests) that lacks SANITY, you may
1846 # be able to delete or create a file when the containing directory
1847 # doesn't have write permissions, or access a file even if the
1848 # containing directory doesn't have read or execute permissions.
1850 test_lazy_prereq SANITY
'
1851 mkdir SANETESTD.1 SANETESTD.2 &&
1853 chmod +w SANETESTD.1 SANETESTD.2 &&
1854 >SANETESTD.1/x 2>SANETESTD.2/x &&
1855 chmod -w SANETESTD.1 &&
1856 chmod -r SANETESTD.1/x &&
1857 chmod -rx SANETESTD.2 ||
1858 BUG "cannot prepare SANETESTD"
1860 ! test -r SANETESTD.1/x &&
1861 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1864 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1865 rm -rf SANETESTD.1 SANETESTD.2 ||
1866 BUG "cannot clean SANETESTD"
1870 test FreeBSD
!= $uname_s || GIT_UNZIP
=${GIT_UNZIP:-/usr/local/bin/unzip}
1871 GIT_UNZIP
=${GIT_UNZIP:-unzip}
1872 test_lazy_prereq UNZIP
'
1877 run_with_limited_cmdline
() {
1878 (ulimit -s 128 && "$@")
1881 test_lazy_prereq CMDLINE_LIMIT
'
1882 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1883 run_with_limited_cmdline true
1886 run_with_limited_stack
() {
1887 (ulimit -s 128 && "$@")
1890 test_lazy_prereq ULIMIT_STACK_SIZE
'
1891 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1892 run_with_limited_stack true
1895 run_with_limited_open_files
() {
1896 (ulimit -n 32 && "$@")
1899 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS
'
1900 test_have_prereq !MINGW,!CYGWIN &&
1901 run_with_limited_open_files true
1905 git version
--build-options |
1906 sed -ne "s/^$1: //p"
1909 test_lazy_prereq SIZE_T_IS_64BIT
'
1910 test 8 -eq "$(build_option sizeof-size_t)"
1913 test_lazy_prereq LONG_IS_64BIT
'
1914 test 8 -le "$(build_option sizeof-long)"
1917 test_lazy_prereq TIME_IS_64BIT
'test-tool date is64bit'
1918 test_lazy_prereq TIME_T_IS_64BIT
'test-tool date time_t-is64bit'
1920 test_lazy_prereq CURL
'
1924 # SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1925 # which will not work with other hash algorithms and tests that work but don't
1926 # test anything meaningful (e.g. special values which cause short collisions).
1927 test_lazy_prereq SHA1
'
1928 case "$GIT_DEFAULT_HASH" in
1930 "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1935 # Ensure that no test accidentally triggers a Git command
1936 # that runs the actual maintenance scheduler, affecting a user's
1937 # system permanently.
1938 # Tests that verify the scheduler integration must set this locally
1940 GIT_TEST_MAINT_SCHEDULER
="none:exit 1"
1942 # Does this platform support `git fsmonitor--daemon`
1944 test_lazy_prereq FSMONITOR_DAEMON
'
1945 git version --build-options >output &&
1946 grep "feature: fsmonitor--daemon" output